SystemOrganization addCategory: #'Magritte-VisualWorks'!

!Behavior methodsFor: '*magritte-visualworks' stamp: 'lr 3/9/2006 11:35'!
visualworksName
	^ self name! !

VW5PackageExporter subclass: #MAVisualWorksExporter
	instanceVariableNames: ''
	classVariableNames: 'PrefixRegistry ObjectRegistry'
	poolDictionaries: ''
	category: 'Magritte-VisualWorks'!

!MAVisualWorksExporter class methodsFor: 'initialization' stamp: 'nfr 9/26/2007 11:03'!
fileOutForVisualWorks
	self fileOutPackageNamed: 'Magritte-Model'.
	self fileOutPackageNamed: 'Magritte-Tests'.
	self fileOutPackageNamed: 'Magritte-Seaside'.! !

!MAVisualWorksExporter class methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:35'!
initialize
	ObjectRegistry := Dictionary new
		at: 'ProtoObject' put: '';
		at: 'Object' put: 'Squeak.Object';
		at: 'TestCase' put: 'XProgramming.SUnit.TestCase';
		at: 'TestResource' put: 'XProgramming.SUnit.TestResource';
		at: 'TestSuite' put: 'XProgramming.SUnit.TestSuite';
		at: 'SmaCCScanner' put: 'Refactory.SmaCC.SmaCCScanner';
		at: 'SmaCCParser' put: 'Refactory.SmaCC.SmaCCParser';
		yourself.
	PrefixRegistry := Dictionary new
		at: 'WA' put: 'Seaside';
		at: 'MA' put: 'Magritte';
		at: 'SW2' put: 'SmallWiki2';
		yourself! !

!MAVisualWorksExporter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:35'!
environment
	^ super environment copyUpTo: $-! !

!MAVisualWorksExporter methodsFor: 'file-out' stamp: 'lr 3/9/2006 11:35'!
fileOutClassCommentForClass: aClass
	aClass hasComment ifFalse: [ ^ self ].
	self tag: 'comment' do: [
		self tag: 'class-id' with: (self fullyQualifiedClassNameFor: aClass).
		self tag: 'body' with: aClass comment asString ]! !

!MAVisualWorksExporter methodsFor: 'file-out' stamp: 'lr 3/9/2006 11:35'!
fileOutClassDefinition: aClass
	super fileOutClassDefinition: aClass.
	self fileOutClassCommentForClass: aClass! !

!MAVisualWorksExporter methodsFor: 'file-out' stamp: 'lr 3/9/2006 11:35'!
fileOutNameSpace
	self tag: 'name-space' do: [
		self tag: 'name' with: self environment.
		self tag: 'environment' with: 'Smalltalk'.
		self tag: 'private' with: 'false'.
		self tag: 'imports' do: [
			self nameSpaceImports do: [ :each |
				stream nextPutAll: 'private '; nextPutAll: each; nextPutAll: '.*'; cr ] ].
		self tag: 'category' with: self environment.
		self tag: 'attributes' do: [
			self tag: 'package' with: self environment ] ]! !

!MAVisualWorksExporter methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:35'!
fullyQualifiedClassNameFor: aClass
	| position |
	ObjectRegistry at: aClass name ifPresent: [ :value | ^ value ].
	position := 1 max: (aClass name findFirst: [ :each | each isLowercase ]) - 2.
	^ String streamContents: [ :output |
		PrefixRegistry
			at: (aClass name copyFrom: 1 to: position)
			ifPresent: [ :value | output nextPutAll: value; nextPut: $. ].
		output nextPutAll: aClass visualworksName ]! !

!MAVisualWorksExporter methodsFor: 'accessing' stamp: 'nfr 10/16/2007 15:40'!
nameSpaceImports
	"Magritte deleted - a namespace does not have to import itself.  Squeak added;  not all relevant classes have been cloned to Seaside.  Namespaces reordered to give correct first-find order."

	^ #('Seaside' 'Squeak' 'Smalltalk')! !

!MAVisualWorksExporter methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:35'!
packageNameForMethod: aMethodReference
	^ (package includesClass: aMethodReference actualClass)
		ifTrue: [ self packageNameForClass: aMethodReference actualClass ]
		ifFalse: [ package externalName , '-Extensions' ]! !
MAVisualWorksExporter initialize!
